Packaging:ScriptletSnippets

From FedoraProject

(Difference between revisions)
Jump to: navigation, search
m (Fix typo)
(Drop systemd-sysv-convert usage.)
(46 intermediate revisions by 4 users not shown)
Line 6: Line 6:
 
'''Contents:'''
 
'''Contents:'''
  
 +
= Default Shell =
 +
In Fedora, you can assume that the default shell (/bin/sh) is bash. Thus, all scriptlets can safely assume that if they are running in shell code, they are running within bash.
  
 
= Syntax =
 
= Syntax =
Line 29: Line 31:
 
|}
 
|}
  
Note that these values will vary if there are multiple versions of the same package installed (This mostly occurs with parallel installable packages such as the kernel.  However, it can also occur when errors prevent a package upgrade form completing.)  So it is a good idea to use this construct:
+
Note that these values will vary if there are multiple versions of the same package installed (This mostly occurs with parallel installable packages such as the kernel and multilib packages.  However, it can also occur when errors prevent a package upgrade from completing.)  So it is a good idea to use this construct:
 
<pre>
 
<pre>
 
%pre
 
%pre
Line 42: Line 44:
  
 
{{Anchor|order}}
 
{{Anchor|order}}
 +
 
= Scriptlet Ordering =
 
= Scriptlet Ordering =
 
The scriptlets in %pre and %post are respectively run before and after a package is installed.  The scriptlets %preun and %postun are run before and after a package is uninstalled.  The scriptlets %pretrans and %posttrans are run at start and end of a transaction.  On upgrade, the scripts are run in the following order:
 
The scriptlets in %pre and %post are respectively run before and after a package is installed.  The scriptlets %preun and %postun are run before and after a package is uninstalled.  The scriptlets %pretrans and %posttrans are run at start and end of a transaction.  On upgrade, the scripts are run in the following order:
Line 49: Line 52:
 
# (package install)
 
# (package install)
 
# %post of new package
 
# %post of new package
 +
# %triggerin of other packages (set off by installing new package)
 +
# %triggerin of new package (if any are true)
 +
# %triggerun of old package (if it's set off by uninstalling the old package)
 +
# %triggerun of other packages (set off by uninstalling old package)
 
# %preun of old package
 
# %preun of old package
 
# (removal of old package)
 
# (removal of old package)
 
# %postun of old package
 
# %postun of old package
 +
# %triggerpostun of old package (if it's set off by uninstalling the old package)
 +
# %triggerpostun of other packages (if they're setu off by uninstalling the old package)
 
# %posttrans of new package
 
# %posttrans of new package
 +
 +
= Writing scriptlets =
 +
 +
Some tips for writing good scriptlets
 +
 +
== Saving state between scriptlets ==
 +
 +
Sometimes a scriptlet needs to save some state from an earlier running scriptlet in order to use it at a later running scriptlet.  This is especially common when trying to optimize the scriptlets.  Examples:
 +
 +
* If a <code>%posttrans</code> needs to de-register some piece of information when upgrading but the file that has that information is removed when the old package is removed the scriptlets need to save that file during <code>%pre</code> or <code>%post</code> so that the script in <code>%posttrans</code> can access it.
 +
* If we only want the program in <code>%posttrans</code> to do its work once per-transaction, we may need to write out a flag file so that the <code>%posttrans</code> knows whether to perform an action.
 +
 +
To address these issues scriptlets that run earlier need to write out information that is used in <code>%posttrans</code>.  We recommend using a subdirectory of <code>%{_localstatedir}/lib/rpm-state/</code> for that.  For instance, the eclipse plugin scripts touch a file in <code>%{_localstatedir}/lib/rpm-state/eclipse/</code> when they're installed.  The <code>%posttrans</code> runs a script that checks if that file exists.  If it does, it performs its action and then deletes the file.  That way the script only performs its action once per transaction.
 +
 +
{{admon/note||We're asking that the <code>%{_localstatedir}/lib/rpm-state/</code> directory be owned by either the rpm or filesystem packages in Fedora.  Until that happens, a package that is providing this functionality needs to own <code>%{_localstatedir}/lib/rpm-state/</code> as well as their subdirectory of it.}}
 +
 +
== Macros ==
 +
Complex scriptlets may be placed in rpm macros.  This has two benefits:
 +
 +
# The standard package authors only have to remember the macros, not the complex stuff that it does
 +
# The macros' implementations may change without having to update the package
 +
 +
When writing the macros, the FPC will still want to review the macros (and perhaps include the implementation of the macros in the guideline to show packagers what's happening behind the scenes).
 +
 +
One principle that the FPC follows is that macros must not contain the start of scriptlet tags (for instance, <code>%pre</code>).  This also means that a single macro must not be defined to do things in both <code>%pre</code> and <code>%post</code>.  Instead, write one macro that performs the actions in <code>%pre</code> and a separate macro that performs the actions in <code>%post</code>.  This principle makes it so that all spec files can use your macros in the same manner even if they already have a <code>%pre</code> or <code>%post</code> defined.
  
 
= Snippets =
 
= Snippets =
Line 93: Line 127:
 
<pre>
 
<pre>
 
%install
 
%install
rm -rf $RPM_BUILD_ROOT
 
 
export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1
 
export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1
 
make install DESTDIR=$RPM_BUILD_ROOT
 
make install DESTDIR=$RPM_BUILD_ROOT
Line 108: Line 141:
 
Here's the second part:
 
Here's the second part:
 
<pre>
 
<pre>
 +
BuildRequires: GConf2
 
Requires(pre): GConf2
 
Requires(pre): GConf2
 
Requires(post): GConf2
 
Requires(post): GConf2
Line 113: Line 147:
 
...
 
...
 
%pre
 
%pre
if [ "$1" -gt 1 ] ; then
+
%gconf_schema_prepare schema1 schema2
export GCONF_CONFIG_SOURCE=<code>gconftool-2 --get-default-source</code>
+
%gconf_schema_obsolete schema3
gconftool-2 --makefile-uninstall-rule \
+
%{_sysconfdir}/gconf/schemas/[NAME] .schemas >/dev/null || :
+
fi
+
 
</pre>
 
</pre>
In this section we uninstall the old schemas when we upgrade.  The way we do this is first to get information about where gconf stores its values via the gconftool-2 --get-default-source lineThen we uninstall the schema from that sourceIf the package could be upgrading a package which had another name for the schema at one time, then we uncomment the lines to uninstall those as well.
+
In this section we uninstall old schemas during upgrade using one of two macros.
 +
 
 +
<code>%gconf_schema_prepare</code> is used for any current GConf schemasIt
 +
takes care of uninstalling previous versions of schemas that this package
 +
currently installsIt takes a space separated list of schema names without
 +
path or suffix that the package installsNote that behind the scenes, this
 +
macro works with the <code>%post</code> scriptlet to only process GConf schemas
 +
if changes have occurred.
 +
 
 +
<code>%gconf_schema_obsolete</code> is used for schemas that this package
 +
previously provided but no longer does.  It will deregister the old schema if
 +
it is present on the system.  Nothing will happen if the old schema is not
 +
present.  This macro takes a space separated list of schemas to uninstall. One
 +
example of using this might be if the package changed names.  If the old schema
 +
was named <code>foo.schemas</code> and the new schema is named
 +
<code>foobar.schemas</code> you'd use:
  
The next section is for installing the new schema:
+
<pre>
 +
%gconf_schema_prepare foobar
 +
%gconf_schema_obsolete foo
 +
</pre>
 +
 
 +
The next section does the processing of the newly installed schemas:
 
<pre>
 
<pre>
 
%post
 
%post
export GCONF_CONFIG_SOURCE=<code>gconftool-2 --get-default-source</code>
+
%gconf_schema_upgrade schema1 schema2
gconftool-2 --makefile-install-rule \
+
%{_sysconfdir}/gconf/schemas/[NAME] .schemas > /dev/null || :
+
 
</pre>
 
</pre>
Here we do the same things as in the %pre section for upgrading except the gconftool-2 switch used is --makefile-install-rule to install the new schemas instead of the uninstall-rule to remove the old schemas.
 
  
The last section deals with deleting the schemas on package removal:
+
<code>%gconf_schema_upgrade</code> takes a space separated list of schemas that
 +
the package currently installs just like <code>%gconf_schema_prepare</code>.
 +
Behind the scenes, it does the actual work of registering the new version of
 +
the schema and deregistering the old version.
 +
 
 +
The last section is for unregistering schemas when a package is removed:
 
<pre>
 
<pre>
 
%preun
 
%preun
if [ "$1" -eq 0 ] ; then
+
%gconf_schema_remove schema1 schema2
export GCONF_CONFIG_SOURCE=<code>gconftool-2 --get-default-source</code>
+
</pre>
gconftool-2 --makefile-uninstall-rule \
+
When a package is upgraded rpm invokes the <code>%pre</code> scriptlet to register
%{_sysconfdir}/gconf/schemas/[NAME] .schemas > /dev/null || :
+
and deregister the schemas.  When a package is uninstalled, the
 +
<code>%preun</code> scriptlet is used.  <code>%gconf_schema_remove</code> takes
 +
the list of schemas that this package currently provides and removes them for us.
 +
 
 +
=== Rebuilds for changes to macros ===
 +
When macros change, packages that make use of them have to be rebuilt to
 +
pick up the changes.  This repoquery command can be used to find the schema
 +
including packages to rebuild:
 +
<pre>
 +
repoquery --whatprovides "/etc/gconf/schemas/*" |sort |uniq |wc -l
 +
</pre>
 +
 
 +
=== EPEL Notes ===
 +
EPEL does not have macros.gconf2, so please follow the instructions found here: [[Packaging:EPEL#GConf]]
 +
 
 +
== GSettings Schema ==
 +
 
 +
GSettings is the configuration system used by the GNOME 3 desktop. It replaces the older GConf
 +
system, which was used in GNOME 2. GSettings has pluggable backends, the 'native' one for GNOME is using DConf to store settings. The GSettings API and utilities are part of the glib2 package.
 +
 
 +
Programs which use GSettings install schema information including default values in the directory %{_datadir}/glib-2.0/schemas. Schema files are xml files with the extension .gschema.xml. At runtime, GSettings uses the schemas in a compiled binary (but arch-neutral) form, which is created by running the glib-compile-schemas utility. /usr/bin/glib-compile-schemas must be run whenever the set of installed schemas changes.
 +
 
 +
<pre>
 +
%postun
 +
if [ $1 -eq 0 ] ; then
 +
    /usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas &> /dev/null || :
 
fi
 
fi
 +
 +
%posttrans
 +
    /usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas &> /dev/null || :
 
</pre>
 
</pre>
This snippet is nearly the same as the one for upgrading.  Why can't we just combine this portion with the  %pre portion?  The answer is that we want to delete any old versions of the schema during an upgrade.  But this has to happen before we install the new version (in the %post script) otherwise we end up removing the schema that the upgrading package installs.  However, if it really is a removal that will leave no other instances of this package on the system, we have to clean up the schema before deleting it.
 
  
'''Note:''' RHEL4 and FC <= 4 suffer from GConf [https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=173869 Bug #173869] . If you are building for EPEL-4, you need to add <code> killall -HUP gconfd-2 > /dev/null || : </code> after the gconftool-2 calls in all the scriptlets.
+
== gdk-pixbuf loaders ==
 +
 
 +
gdk-pixbuf is a library that is part of the gdk-pixbuf2 package. It is for loading images in various formats in GNOME. gdk-pixbuf can be extended by implementing loaders for image formats in loadable modules. These loadable modules have to be installed in %{_libdir}/gdk-pixbuf-2.0/2.10.0/loaders. To avoid opening all modules in that directory unnecessarily, gdk-pixbuf maintains a cache with information about the available modules in the text file %{_libdir}/gdk-pixbuf-2.0/2.10.0/loaders.cache. This cache file needs to be updated when the set of installed modules changes, by calling the /usr/bin/gdk-pixbuf-query-loaders binary. Multilib considerations force us to install the binary in -32 and -64 variants.
 +
 
 +
The scriptlets to maintain the cache file are:
 +
<pre>
 +
%postun
 +
    /usr/bin/gdk-pixbuf-query-loaders-%{__isa_bits} --update-cache &> /dev/null || :
 +
 
 +
%post
 +
if [ $1 -eq 1 ] ; then
 +
    # For upgrades, the cache will be regenerated by the new package's %postun
 +
    /usr/bin/gdk-pixbuf-query-loaders-%{__isa_bits} --update-cache &> /dev/null || :
 +
fi
 +
</pre>
 +
 
 +
Note the use of %{__isa_bits}, which is an rpm macro that expands to either 32 or 64,
 +
depending on the architecture of the package.
 +
 
 +
== GTK+ modules ==
 +
 
 +
The GTK+ toolkit (in the gtk3 package) can be extended by loadable modules which can provide theme engines, input methods, print backends or other functionality. These modules have to be installed in subdirectories of %{_libdir}/gtk-3.0 or %{_libdir}/gtk-3.0/3.0.0. For the input methods, GTK+ maintains a cache in the text file %{_libdir}/gtk-3.0/3.0.0/immodules.cache. This cache file needs to be updated when the set of installed input methods changes, by calling the gtk-query-immodules-3.0 binary. Multilib considerations force us to install the binary in -32 and -64 variants.
 +
 
 +
The scriptlets to maintain the cache file are:
 +
<pre>
 +
%postun
 +
/usr/bin/gtk-query-immodules-3.0-%{__isa_bits} --update-cache &> /dev/null || :
 +
 
 +
%post
 +
if [ $1 -eq 1 ] ; then
 +
    # For upgrades, the cache will be regenerated by the new package's %postun
 +
    /usr/bin/gtk-query-immodules-3.0-%{__isa_bits} --update-cache &> /dev/null || :
 +
fi
 +
</pre>  
 +
 
 +
The 3.0 in the binary name is there because gtk2 has its own utility for the same purpose, called gtk-query-immodules-2.0. Note the use of %{__isa_bits}, which is an rpm macro that expands to either 32 or 64, depending on the architecture of the package.
 +
 
 +
== GIO modules ==
 +
GIO is a library that is part of the glib2 package. It is a low-level part of the GNOME stack.  GIO can be extended by implementing [http://library.gnome.org/devel/gio/2.26/extending-gio.html extension points] in loadable modules. These loadable modules have to be installed in %{_libdir}/gio/modules. To avoid opening all modules in that directory
 +
unnecessarily, GIO maintains a cache with information about the available modules in the
 +
text file giomodule.cache in the same directory. This cache file needs to be updated when the set of installed modules changes, by calling the gio-querymodules binary. Multilib considerations force us to install the binary in -32 and -64 variants.
 +
 
 +
The scriptlets to maintain the cache file are:
 +
<pre>
 +
%postun
 +
/usr/bin/gio-querymodules-%{__isa_bits} %{_libdir}/gio/modules &> /dev/null || :
 +
 
 +
%post
 +
# We run this after every install or upgrade because of a cornercase
 +
# when installing the second architecture of a multilib package
 +
/usr/bin/gio-querymodules-%{__isa_bits} %{_libdir}/gio/modules || :
 +
</pre>
 +
 
 +
Note the use of %{__isa_bits}, which is an rpm macro that expands to either 32 or 64,
 +
depending on the architecture of the package.
  
 
{{Anchor|info}}
 
{{Anchor|info}}
Line 165: Line 299:
  
 
{{Anchor|scrollkeeper}}
 
{{Anchor|scrollkeeper}}
 
 
== Scrollkeeper ==
 
== Scrollkeeper ==
Gnome and KDE use the scrollkeeper cataloging system to keep track of documentation installed on the systemScrollkeeper allows the help system to sort and search documentation metadata stored in .omf filesWhen you add documentation in these systems you need to make scrollkeeper aware that the documentation has been changed.
+
In all current Fedora, rarian has replaced scrollkeeper.  There is no scriptlet needed for rarianFor instructions on what to do in EPEL releases, see [[Packaging:EPEL#Scrollkeeper]]
 
+
Note that we ''''''BuildRequires scrollkeeper as most Makefile's are setup to install the necessary scrollkeeper files only if scrollkeeper is present at install time.
+
<pre>
+
BuildRequires: scrollkeeper
+
Requires(post): scrollkeeper
+
Requires(postun): scrollkeeper
+
...
+
%post
+
scrollkeeper-update -q -o %{_datadir}/omf/%{name} || :
+
 
+
%postun
+
scrollkeeper-update -q || :
+
</pre>
+
These two scriptlets tell scrollkeeper to update its indexes to account for the new scrollkeeper files.
+
 
+
  
 
{{Anchor|desktopdb}}
 
{{Anchor|desktopdb}}
Line 189: Line 307:
 
<pre>
 
<pre>
 
%post
 
%post
update-desktop-database &> /dev/null || :
+
/usr/bin/update-desktop-database &> /dev/null || :
  
 
%postun
 
%postun
update-desktop-database &> /dev/null || :
+
/usr/bin/update-desktop-database &> /dev/null || :
 
</pre>
 
</pre>
 
Note: For FC5+, this scriptlet follows the same convention as mimeinfo files and gtk-icon-cache.  Namely, the spec file should not Require desktop-file-utils for this.  For older releases, one should
 
Note: For FC5+, this scriptlet follows the same convention as mimeinfo files and gtk-icon-cache.  Namely, the spec file should not Require desktop-file-utils for this.  For older releases, one should
Line 206: Line 324:
 
<pre>
 
<pre>
 
%post
 
%post
update-mime-database %{_datadir}/mime &> /dev/null || :
+
/usr/bin/update-mime-database %{_datadir}/mime &> /dev/null || :
  
 
%postun
 
%postun
update-mime-database %{_datadir}/mime &> /dev/null || :
+
/usr/bin/update-mime-database %{_datadir}/mime &> /dev/null || :
 
</pre>
 
</pre>
 
Note that similarly to the gtk-update-icon-cache code, these scriptlets should be run only if the user has update-mime-info installed and without a specific Requires: shared-mime-info.  If shared-mime-info is not installed, update-mime-database won't be run when this package is installed.  This does not matter because it will be run when the shared-mime-info package is installed.
 
Note that similarly to the gtk-update-icon-cache code, these scriptlets should be run only if the user has update-mime-info installed and without a specific Requires: shared-mime-info.  If shared-mime-info is not installed, update-mime-database won't be run when this package is installed.  This does not matter because it will be run when the shared-mime-info package is installed.
Line 222: Line 340:
 
<pre>
 
<pre>
 
%post
 
%post
touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :
+
/bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :
  
 
%postun
 
%postun
 
if [ $1 -eq 0 ] ; then
 
if [ $1 -eq 0 ] ; then
     touch --no-create %{_datadir}/icons/hicolor &>/dev/null
+
     /bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null
     gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
+
     /usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
 
fi
 
fi
  
 
%posttrans
 
%posttrans
gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
+
/usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
 
</pre>
 
</pre>
 +
 +
== Systemd ==
 +
 +
Packages containing systemd unit files need to use scriptlets to ensure proper handling of those services. Services can either be enabled or disabled by default. To determine which case your specific service falls into, please refer to FESCo's policy here: [[Starting_services_by_default]]. On upgrade, a package may only restart a service if it is running; it may not start it if it is off.  Also, the service may not enable itself if it is currently disabled.
 +
 +
=== New Packages ===
 +
{{admon/note|What is a new package?|In this context, a new package is a package which has never included a SysV initscript.}}
 +
 +
==== Macroized scriptlets (Fedora 18+) ====
 +
The systemd package in Fedora 18+ provides a set of helper macros to handle systemd scriptlet operations. These macros are functionally equivalent to the manual scriptlets used in older versions of Fedora, but they also add support for systemd "presets", as documented here: https://fedoraproject.org/wiki/Features/PackagePresets
 +
 +
<pre>
 +
Requires(post): systemd
 +
Requires(preun): systemd
 +
Requires(postun): systemd
 +
 +
[...]
 +
%post
 +
%systemd_post apache-httpd.service
 +
 +
%preun
 +
%systemd_preun apache-httpd.service
 +
 +
%postun
 +
%systemd_postun_with_restart apache-httpd.service
 +
</pre>
 +
 +
Some services do not support being restarted (e.g. D-Bus and various storage daemons). If your service should not be restarted upon upgrade, then use the following <code>%post</code> scriptlet instead of the one shown above:
 +
<pre>
 +
%postun
 +
%systemd_postun
 +
</pre>
 +
 +
If your package includes one or more systemd units that need to be enabled by default on package installation, they need to be covered by the default Fedora preset policy. [http://pkgs.fedoraproject.org/cgit/systemd.git/plain/90-default.preset The default fedora preset policy is shipped as part of systemd.rpm]. If your unit files are missing from this list, please file a bug against the systemd package. Only services covered by the [https://fedoraproject.org/wiki/Starting_services_by_default policy on which services that may be enabled by default on package installation] are eligible for this, and you will need to receive special permission from FESCo to have a package start a service by default if it is not covered by the existing policy.
 +
 +
For details on what these macros evaluate to, refer to the following sources:<BR>
 +
http://cgit.freedesktop.org/systemd/systemd/tree/src/core/macros.systemd.in<BR>
 +
http://www.freedesktop.org/software/systemd/man/daemon.html
 +
 +
==== Manual scriptlets (Fedora 17 or older) ====
 +
<pre>
 +
Requires(post): systemd-units
 +
Requires(preun): systemd-units
 +
Requires(postun): systemd-units
 +
 +
[...]
 +
%post
 +
if [ $1 -eq 1 ] ; then
 +
    # Initial installation
 +
    /bin/systemctl daemon-reload >/dev/null 2>&1 || :
 +
fi
 +
 +
%preun
 +
if [ $1 -eq 0 ] ; then
 +
    # Package removal, not upgrade
 +
    /bin/systemctl --no-reload disable apache-httpd.service > /dev/null 2>&1 || :
 +
    /bin/systemctl stop apache-httpd.service > /dev/null 2>&1 || :
 +
fi
 +
 +
%postun
 +
/bin/systemctl daemon-reload >/dev/null 2>&1 || :
 +
if [ $1 -ge 1 ] ; then
 +
    # Package upgrade, not uninstall
 +
    /bin/systemctl try-restart apache-httpd.service >/dev/null 2>&1 || :
 +
fi
 +
</pre>
 +
Note that /bin/systemctl daemon-reload will automatically detect new systemd unit .service files placed into %{_unitdir}. There is no equivalent to 'chkconfig --add <service>', because it is unnecessary. However, if the service is not enabled by default, systemctl will not list your service until it is either manually started (<code>systemctl start foo.service</code>) or manually enabled (<code>systemctl enable foo.service</code>).
 +
 +
If your service should be enabled by default, then use the following <code>%post</code> scriptlet instead of the one shown above:
 +
<pre>
 +
%post
 +
if [ $1 -eq 1 ] ; then
 +
    # Initial installation
 +
    /bin/systemctl enable apache-httpd.service >/dev/null 2>&1 || :
 +
fi
 +
</pre>
 +
 +
=== Packages migrating to a systemd unit file from a SysV initscript ===
 +
 +
When updating from a package containing a SysV initscript to a package containing a systemd unit file, we "start-over fresh" with default start and stop policy from the new package and do not migrate what the user had previously configured.  For this reason, you can simply use the above scriptlets and not worry about converting the sysv information to something relevant to systemd.
 +
 +
{{admon/warning|Only migrate between releases|Packages are strictly forbidden from migrating to systemd within updates to a Fedora release because migration will reset the user's choices about whether to start or stop the service. Migration is only allowed between Fedora releases.}}
 +
 +
[[Category:Packaging guidelines]]

Revision as of 17:22, 11 July 2013

Contents

RPM scriptlet recipes

Rpm spec files have several sections which allow packages to run code on installation and removal. These scriptlets are mostly used to update the running system with information from the package. This page offers a quick overview of the RPM scriptlets and a number of common recipes for scriptlets in packages. For a more complete treatment of scriptlets, please see the Maximum RPM book .

Contents:

Default Shell

In Fedora, you can assume that the default shell (/bin/sh) is bash. Thus, all scriptlets can safely assume that if they are running in shell code, they are running within bash.

Syntax

The basic syntax is similar to the %build, %install, and other sections of the rpm spec file. The scripts support a special flag, -p which allows the scriptlet to invoke a single program directly rather than having to spawn a shell to invoke the programs. (ie: %post -p /sbin/ldconfig)

The scriptlets also take an argument, passed into them by the controlling rpmbuild process. This argument, accessed via $1 is the number of packages of this name which will be left on the system when the action completes, except for %pretrans and %posttrans which are always run with $1 as 0 (%pretrans and %posttrans are available in rpm 4.4 and later). So for the common case of install, upgrade, and uninstall we have:

install upgrade uninstall
 %pretrans $1 == 0 $1 == 0 (N/A)
 %pre $1 == 1 $1 == 2 (N/A)
 %post $1 == 1 $1 == 2 (N/A)
 %preun (N/A) $1 == 1 $1 == 0
 %postun (N/A) $1 == 1 $1 == 0
 %posttrans $1 == 0 $1 == 0 (N/A)

Note that these values will vary if there are multiple versions of the same package installed (This mostly occurs with parallel installable packages such as the kernel and multilib packages. However, it can also occur when errors prevent a package upgrade from completing.) So it is a good idea to use this construct:

%pre
if [ $1 -gt 1 ] ; then
fi

...for %pre and %post scripts rather than checking that it equals 2.

Except in some really exceptional cases (if any), we want all scriptlets to exit with the zero exit status. Because rpm in its default configuration does not at the moment execute shell scriptlets with the -e argument to the shell, excluding explicit exit calls (frowned upon with a non-zero argument!), the exit status of the last command in a scriptlet determines its exit status. Most commands in the snippets in this document have a "|| :" appended to them, which is a generic trick to force the zero exit status for those commands whether they worked or not. Usually the most important bit is to apply this to the last command executed in a scriptlet, or to add a separate command such as plain ":" or "exit 0" as the last one in a scriptlet. Note that depending on the case, other error checking/prevention measures may be more appropriate, as well as running some commands only if we saw a previous command in the scriptlet which is a must prerequisite to succeed.

Non-zero exit codes from scriptlets break installs/upgrades/erases so that no further actions will be taken for that package in a transaction (see scriptlet ordering below), which may for example prevent an old version of a package from being erased on upgrades, leaving behind duplicate rpmdb entries and possibly stale, unowned files on the filesystem. There are some cases where letting the transaction to proceed when some things in scriptlets failed may result in partially broken setup. It is however often limited to that package only whereas letting a transaction to proceed with some packages dropped out on the fly is more likely to result in broader system wide problems.

Scriptlet Ordering

The scriptlets in %pre and %post are respectively run before and after a package is installed. The scriptlets %preun and %postun are run before and after a package is uninstalled. The scriptlets %pretrans and %posttrans are run at start and end of a transaction. On upgrade, the scripts are run in the following order:

  1.  %pretrans of new package
  2.  %pre of new package
  3. (package install)
  4.  %post of new package
  5.  %triggerin of other packages (set off by installing new package)
  6.  %triggerin of new package (if any are true)
  7.  %triggerun of old package (if it's set off by uninstalling the old package)
  8.  %triggerun of other packages (set off by uninstalling old package)
  9.  %preun of old package
  10. (removal of old package)
  11.  %postun of old package
  12.  %triggerpostun of old package (if it's set off by uninstalling the old package)
  13.  %triggerpostun of other packages (if they're setu off by uninstalling the old package)
  14.  %posttrans of new package

Writing scriptlets

Some tips for writing good scriptlets

Saving state between scriptlets

Sometimes a scriptlet needs to save some state from an earlier running scriptlet in order to use it at a later running scriptlet. This is especially common when trying to optimize the scriptlets. Examples:

  • If a %posttrans needs to de-register some piece of information when upgrading but the file that has that information is removed when the old package is removed the scriptlets need to save that file during %pre or %post so that the script in %posttrans can access it.
  • If we only want the program in %posttrans to do its work once per-transaction, we may need to write out a flag file so that the %posttrans knows whether to perform an action.

To address these issues scriptlets that run earlier need to write out information that is used in %posttrans. We recommend using a subdirectory of %{_localstatedir}/lib/rpm-state/ for that. For instance, the eclipse plugin scripts touch a file in %{_localstatedir}/lib/rpm-state/eclipse/ when they're installed. The %posttrans runs a script that checks if that file exists. If it does, it performs its action and then deletes the file. That way the script only performs its action once per transaction.

Note.png
We're asking that the %{_localstatedir}/lib/rpm-state/ directory be owned by either the rpm or filesystem packages in Fedora. Until that happens, a package that is providing this functionality needs to own %{_localstatedir}/lib/rpm-state/ as well as their subdirectory of it.

Macros

Complex scriptlets may be placed in rpm macros. This has two benefits:

  1. The standard package authors only have to remember the macros, not the complex stuff that it does
  2. The macros' implementations may change without having to update the package

When writing the macros, the FPC will still want to review the macros (and perhaps include the implementation of the macros in the guideline to show packagers what's happening behind the scenes).

One principle that the FPC follows is that macros must not contain the start of scriptlet tags (for instance, %pre). This also means that a single macro must not be defined to do things in both %pre and %post. Instead, write one macro that performs the actions in %pre and a separate macro that performs the actions in %post. This principle makes it so that all spec files can use your macros in the same manner even if they already have a %pre or %post defined.

Snippets

Shared libraries

Installing shared libraries requires running /sbin/ldconfig to update the dynamic linker's cache files. These can be invoked like:

%post
/sbin/ldconfig
%postun
/sbin/ldconfig

It is also common to invoke these with the '-p' option as they are often the only program invoked in a scriptlet:

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

If applicable, the latter way is recommended because doing so will automatically add appropriate dependencies on /sbin/ldconfig to the package (and FWIW, will prevent unnecessarily launching a shell process in the scriptlets).

Users and groups

These are discussed on a separate page

Services

Initscripts Conventions

Full guidelines for SysV-style initscripts can be found here: Packaging/SysVInitScript
Scriptlet specifics can be found here: Packaging/SysVInitScript#InitscriptScriptlets

GConf

GConf is a configuration scheme currently used by the GNOME desktop. Programs which use it setup default values in a [NAME] .schemas file which is installed under %{_sysconfdir}/gconf/schemas/[NAME] .schemas. These defaults are then registered with the gconf daemon which monitors the configuration values and alerts applications when values the applications are interested in change. The schema files also provide documentation about what each value in the configuration system means (which gets displayed when you browse the database in the gconf-editor program).

For packaging purposes, we have to disable schema installation during build, and also register the values in the [NAME] .schemas file with the gconf daemon on installation and unregister them on removal. Due to the ordering of the scriptlets, this is a four step process.

Disabling the GConf installation during the package creation can be done like so:

%install
export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1
make install DESTDIR=$RPM_BUILD_ROOT
...

The GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL environment variable suppresses the installation of the schema during the building of the package. An alternative for some packages is to pass a configure flag:

%build
%configure --disable-schemas
...

Unfortunately, this configure switch only works if the upstream packager has adapted their Makefile.am to handle it. If the Makefile.am is not configured, this switch won't do anything and you'll need to use the environment variable instead.

Here's the second part:

BuildRequires: GConf2
Requires(pre): GConf2
Requires(post): GConf2
Requires(preun): GConf2
...
%pre
%gconf_schema_prepare schema1 schema2
%gconf_schema_obsolete schema3

In this section we uninstall old schemas during upgrade using one of two macros.

%gconf_schema_prepare is used for any current GConf schemas. It takes care of uninstalling previous versions of schemas that this package currently installs. It takes a space separated list of schema names without path or suffix that the package installs. Note that behind the scenes, this macro works with the %post scriptlet to only process GConf schemas if changes have occurred.

%gconf_schema_obsolete is used for schemas that this package previously provided but no longer does. It will deregister the old schema if it is present on the system. Nothing will happen if the old schema is not present. This macro takes a space separated list of schemas to uninstall. One example of using this might be if the package changed names. If the old schema was named foo.schemas and the new schema is named foobar.schemas you'd use:

%gconf_schema_prepare foobar
%gconf_schema_obsolete foo

The next section does the processing of the newly installed schemas:

%post
%gconf_schema_upgrade schema1 schema2

%gconf_schema_upgrade takes a space separated list of schemas that the package currently installs just like %gconf_schema_prepare. Behind the scenes, it does the actual work of registering the new version of the schema and deregistering the old version.

The last section is for unregistering schemas when a package is removed:

%preun
%gconf_schema_remove schema1 schema2

When a package is upgraded rpm invokes the %pre scriptlet to register and deregister the schemas. When a package is uninstalled, the %preun scriptlet is used. %gconf_schema_remove takes the list of schemas that this package currently provides and removes them for us.

Rebuilds for changes to macros

When macros change, packages that make use of them have to be rebuilt to pick up the changes. This repoquery command can be used to find the schema including packages to rebuild:

repoquery --whatprovides "/etc/gconf/schemas/*" |sort |uniq |wc -l

EPEL Notes

EPEL does not have macros.gconf2, so please follow the instructions found here: Packaging:EPEL#GConf

GSettings Schema

GSettings is the configuration system used by the GNOME 3 desktop. It replaces the older GConf system, which was used in GNOME 2. GSettings has pluggable backends, the 'native' one for GNOME is using DConf to store settings. The GSettings API and utilities are part of the glib2 package.

Programs which use GSettings install schema information including default values in the directory %{_datadir}/glib-2.0/schemas. Schema files are xml files with the extension .gschema.xml. At runtime, GSettings uses the schemas in a compiled binary (but arch-neutral) form, which is created by running the glib-compile-schemas utility. /usr/bin/glib-compile-schemas must be run whenever the set of installed schemas changes.

%postun
if [ $1 -eq 0 ] ; then
    /usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas &> /dev/null || :
fi

%posttrans
    /usr/bin/glib-compile-schemas %{_datadir}/glib-2.0/schemas &> /dev/null || :

gdk-pixbuf loaders

gdk-pixbuf is a library that is part of the gdk-pixbuf2 package. It is for loading images in various formats in GNOME. gdk-pixbuf can be extended by implementing loaders for image formats in loadable modules. These loadable modules have to be installed in %{_libdir}/gdk-pixbuf-2.0/2.10.0/loaders. To avoid opening all modules in that directory unnecessarily, gdk-pixbuf maintains a cache with information about the available modules in the text file %{_libdir}/gdk-pixbuf-2.0/2.10.0/loaders.cache. This cache file needs to be updated when the set of installed modules changes, by calling the /usr/bin/gdk-pixbuf-query-loaders binary. Multilib considerations force us to install the binary in -32 and -64 variants.

The scriptlets to maintain the cache file are:

%postun
    /usr/bin/gdk-pixbuf-query-loaders-%{__isa_bits} --update-cache &> /dev/null || :

%post
if [ $1 -eq 1 ] ; then
    # For upgrades, the cache will be regenerated by the new package's %postun
    /usr/bin/gdk-pixbuf-query-loaders-%{__isa_bits} --update-cache &> /dev/null || :
fi

Note the use of %{__isa_bits}, which is an rpm macro that expands to either 32 or 64, depending on the architecture of the package.

GTK+ modules

The GTK+ toolkit (in the gtk3 package) can be extended by loadable modules which can provide theme engines, input methods, print backends or other functionality. These modules have to be installed in subdirectories of %{_libdir}/gtk-3.0 or %{_libdir}/gtk-3.0/3.0.0. For the input methods, GTK+ maintains a cache in the text file %{_libdir}/gtk-3.0/3.0.0/immodules.cache. This cache file needs to be updated when the set of installed input methods changes, by calling the gtk-query-immodules-3.0 binary. Multilib considerations force us to install the binary in -32 and -64 variants.

The scriptlets to maintain the cache file are:

%postun
/usr/bin/gtk-query-immodules-3.0-%{__isa_bits} --update-cache &> /dev/null || :

%post
if [ $1 -eq 1 ] ; then
    # For upgrades, the cache will be regenerated by the new package's %postun
    /usr/bin/gtk-query-immodules-3.0-%{__isa_bits} --update-cache &> /dev/null || :
fi

The 3.0 in the binary name is there because gtk2 has its own utility for the same purpose, called gtk-query-immodules-2.0. Note the use of %{__isa_bits}, which is an rpm macro that expands to either 32 or 64, depending on the architecture of the package.

GIO modules

GIO is a library that is part of the glib2 package. It is a low-level part of the GNOME stack. GIO can be extended by implementing extension points in loadable modules. These loadable modules have to be installed in %{_libdir}/gio/modules. To avoid opening all modules in that directory unnecessarily, GIO maintains a cache with information about the available modules in the text file giomodule.cache in the same directory. This cache file needs to be updated when the set of installed modules changes, by calling the gio-querymodules binary. Multilib considerations force us to install the binary in -32 and -64 variants.

The scriptlets to maintain the cache file are:

%postun
/usr/bin/gio-querymodules-%{__isa_bits} %{_libdir}/gio/modules &> /dev/null || :

%post
# We run this after every install or upgrade because of a cornercase
# when installing the second architecture of a multilib package 
/usr/bin/gio-querymodules-%{__isa_bits} %{_libdir}/gio/modules || :

Note the use of %{__isa_bits}, which is an rpm macro that expands to either 32 or 64, depending on the architecture of the package.

Texinfo

The GNU project and many other programs use the texinfo file format for much of its documentation. These info files are usually located in /usr/share/info/. When installing or removing a package, install-info from the info package takes care of adding the newly installed files to the main info index and removing them again on deinstallation.

Requires(post): info
Requires(preun): info
...
%post
/sbin/install-info %{_infodir}/%{name}.info %{_infodir}/dir || :

%preun
if [ $1 = 0 ] ; then
  /sbin/install-info --delete %{_infodir}/%{name}.info %{_infodir}/dir || :
fi

These two scriptlets tell install-info to add entries for the info pages to the main index file on installation and remove them at erase time. The "|| :" in this case prevents failures that would typically affect systems that have been configured not to install any %doc files, or have read-only mounted, %_netsharedpath /usr/share.

Scrollkeeper

In all current Fedora, rarian has replaced scrollkeeper. There is no scriptlet needed for rarian. For instructions on what to do in EPEL releases, see Packaging:EPEL#Scrollkeeper

desktop-database

Use this when a desktop entry has a 'MimeType key.

%post
/usr/bin/update-desktop-database &> /dev/null || :

%postun
/usr/bin/update-desktop-database &> /dev/null || :

Note: For FC5+, this scriptlet follows the same convention as mimeinfo files and gtk-icon-cache. Namely, the spec file should not Require desktop-file-utils for this. For older releases, one should

Requires(post): desktop-file-utils
Requires(postun): desktop-file-utils

(See http://bugzilla.redhat.com/180898 and http://bugzilla.redhat.com/180899)

mimeinfo

Use this when a package drops an XML file in %{_datadir}/mime/packages.

%post
/usr/bin/update-mime-database %{_datadir}/mime &> /dev/null || :

%postun
/usr/bin/update-mime-database %{_datadir}/mime &> /dev/null || :

Note that similarly to the gtk-update-icon-cache code, these scriptlets should be run only if the user has update-mime-info installed and without a specific Requires: shared-mime-info. If shared-mime-info is not installed, update-mime-database won't be run when this package is installed. This does not matter because it will be run when the shared-mime-info package is installed.

Icon Cache

If an application installs icons into one of the subdirectories in %{_datadir}/icons/ (such as hicolor in the following examples), icon caches must be updated so that the installed icons show up in menus right after package installation. This consists of updating the timestamp of the top-level icon directory where the icons were installed, and running gtk-update-icon-cache. 'touch'ing the top-level dir is done so that environments compatible with the Icon theme specification can refresh their caches, and gtk-update-icon-cache which is additionally required for GNOME also does its work based on the dir timestamp.

Note that no dependencies should be added for this. If gtk-update-icon-cache is not available, there's nothing that would be needing the cache update, ditto if "touch" is not available, there's nothing that would benefit from icon cache updates installed yet either. Not adding the dependency on gtk-update-icon-cache (ie. gtk2 >= 2.6.0) or "touch" makes it easier to use the package (or the same specfile) on systems where it's not available nor needed, such as older distro versions or (very) trimmed down installations, and generally results in less entries in specfiles, rpmdb, and repo metadatas.

%post
/bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :

%postun
if [ $1 -eq 0 ] ; then
    /bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null
    /usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
fi

%posttrans
/usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :

Systemd

Packages containing systemd unit files need to use scriptlets to ensure proper handling of those services. Services can either be enabled or disabled by default. To determine which case your specific service falls into, please refer to FESCo's policy here: Starting_services_by_default. On upgrade, a package may only restart a service if it is running; it may not start it if it is off. Also, the service may not enable itself if it is currently disabled.

New Packages

Note.png
What is a new package?
In this context, a new package is a package which has never included a SysV initscript.

Macroized scriptlets (Fedora 18+)

The systemd package in Fedora 18+ provides a set of helper macros to handle systemd scriptlet operations. These macros are functionally equivalent to the manual scriptlets used in older versions of Fedora, but they also add support for systemd "presets", as documented here: https://fedoraproject.org/wiki/Features/PackagePresets

Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

[...]
%post
%systemd_post apache-httpd.service

%preun
%systemd_preun apache-httpd.service

%postun
%systemd_postun_with_restart apache-httpd.service 

Some services do not support being restarted (e.g. D-Bus and various storage daemons). If your service should not be restarted upon upgrade, then use the following %post scriptlet instead of the one shown above:

%postun
%systemd_postun

If your package includes one or more systemd units that need to be enabled by default on package installation, they need to be covered by the default Fedora preset policy. The default fedora preset policy is shipped as part of systemd.rpm. If your unit files are missing from this list, please file a bug against the systemd package. Only services covered by the policy on which services that may be enabled by default on package installation are eligible for this, and you will need to receive special permission from FESCo to have a package start a service by default if it is not covered by the existing policy.

For details on what these macros evaluate to, refer to the following sources:
http://cgit.freedesktop.org/systemd/systemd/tree/src/core/macros.systemd.in
http://www.freedesktop.org/software/systemd/man/daemon.html

Manual scriptlets (Fedora 17 or older)

Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units

[...]
%post
if [ $1 -eq 1 ] ; then 
    # Initial installation 
    /bin/systemctl daemon-reload >/dev/null 2>&1 || :
fi

%preun
if [ $1 -eq 0 ] ; then
    # Package removal, not upgrade
    /bin/systemctl --no-reload disable apache-httpd.service > /dev/null 2>&1 || :
    /bin/systemctl stop apache-httpd.service > /dev/null 2>&1 || :
fi

%postun
/bin/systemctl daemon-reload >/dev/null 2>&1 || :
if [ $1 -ge 1 ] ; then
    # Package upgrade, not uninstall
    /bin/systemctl try-restart apache-httpd.service >/dev/null 2>&1 || :
fi

Note that /bin/systemctl daemon-reload will automatically detect new systemd unit .service files placed into %{_unitdir}. There is no equivalent to 'chkconfig --add <service>', because it is unnecessary. However, if the service is not enabled by default, systemctl will not list your service until it is either manually started (systemctl start foo.service) or manually enabled (systemctl enable foo.service).

If your service should be enabled by default, then use the following %post scriptlet instead of the one shown above:

%post
if [ $1 -eq 1 ] ; then 
    # Initial installation
    /bin/systemctl enable apache-httpd.service >/dev/null 2>&1 || :
fi

Packages migrating to a systemd unit file from a SysV initscript

When updating from a package containing a SysV initscript to a package containing a systemd unit file, we "start-over fresh" with default start and stop policy from the new package and do not migrate what the user had previously configured. For this reason, you can simply use the above scriptlets and not worry about converting the sysv information to something relevant to systemd.

Warning (medium size).png
Only migrate between releases
Packages are strictly forbidden from migrating to systemd within updates to a Fedora release because migration will reset the user's choices about whether to start or stop the service. Migration is only allowed between Fedora releases.